
//create variables and arrays
let table;
var g;
var b;
var px; 
var py;
let counter = 0; 
let blobs = [];
let c37 = [];
let tail = [];

let blob;


poff = []
p2off = []

var xoff;
var yoff;
let wiggle = .0001
let noiseMax = []
let temprowsmax = 148;
let temprowsmin = 75; 
let d15N = []
let size = []

let d15Nmin = 152;
let d15Nmax = 265;
let column;
let sizemin = 1
let sizemax = 10
let sizecounter = 0
let sizearray = []
let MPT = []
let MPTspeed = []
let drawcounter = 0
var fade;
var fadeAmount = 1
//load data
function preload() {
  //my table is comma separated value "csv"
  //and has a header specifying the columns labels
  table = loadTable('table2.csv', 'csv', 'header');

}
//set up canvas and load data into variables and arrays
function setup(){
  createCanvas(windowWidth, windowHeight)
  background(0);
  
  print(table.getRowCount() + ' total rows in table');
  print(table.getColumnCount() + ' total columns in table');
  print(table.getString(0, 8) + 'string 0,8');
  print(table.getString(0, 8) + 'string 0,8');
  print(table.getString(152, 3) + 'string 0,2 d15Nminx');
  print(table.getString(265, 3) + 'string d15Nmax');
  print(table.getString(0,10) + 'string 0,10 MPT')
  print(table.getString(75, 11) + 'mintemp');
  print(table.getString(148, 11) + 'maxtemp');

  for (let v = d15Nmin; v < d15Nmax; v++){
    d15N.push(table.getString(v, 3))
    size.push(map(d15N[v-d15Nmin],1.005066677234081,12.5172262826832,sizemin, sizemax))
  }

  for (let n = temprowsmin; n < temprowsmax; n++){
    c37.push(table.getString(n,12))
    tail.push(map(c37[n-temprowsmin], .113, 6.585, 5,10))
    poff.push(random(0,300))
    noiseMax.push(random(2,4))
    p2off.push(random(0,300))
    sizearray.push(random(size))
    MPT.push(table.getString(n,10))
    if (MPT[n-temprowsmin] == 1){
      MPTspeed[n-temprowsmin] = map(0.03623188406, 0.02597402597, 0.04964539007, .0005, .006)
    }

    if (MPT[n-temprowsmin] == 2){
      MPTspeed[n-temprowsmin] = map(0.03623188406, 0.02597402597, 0.04964539007, .0005, .006)
    }

    if (MPT[n-temprowsmin] == 3){
      MPTspeed[n-temprowsmin] = map(0.04964539007, 0.02597402597, 0.04964539007, .0005, .006)
    }

    if (MPT[n-temprowsmin] == 4){
      MPTspeed[n-temprowsmin] = map(0.02597402597, 0.02597402597, 0.04964539007, .0005, .006)
    }

  }
 
  console.log('MPT array' + MPT)
  console.log(MPTspeed)
  console.log(noiseMax +"noiseMax")

}
//create visuals
function draw(){
  
    for (let i = temprowsmin; i < temprowsmax; i++) {
      var p = map(noise(poff[i-temprowsmin]), 0, 1, 0 ,windowWidth);
      var q = map(noise(p2off[i-temprowsmin]), 0, 1, 0 ,windowHeight);
      temp = table.getString(i,11)
      red = map(temp,15.75,22.785,0,200)
      // fill(red,0,50,75)
      // noStroke();
      noFill();
      stroke(red,0,50,tail[i-temprowsmin]);
      beginShape();
        for (let a = 0; a<TWO_PI; a+=0.2){
            let xoff = map(cos(a), -1, 1, 0, noiseMax[i-temprowsmin]);
            let yoff = map(sin(a), -1,1,0, noiseMax[i-temprowsmin]);
            let r = map(noise(xoff,yoff, wiggle), 0, 1, (5*sizearray[i-temprowsmin])-10, (8*sizearray[i-temprowsmin]));
            let x = r * cos(a)
            let y = r * sin(a);
            vertex(x+p,y+q)
          }
          endShape(CLOSE);
          wiggle += .0001;
          poff[i-temprowsmin] = poff[i-temprowsmin] + MPTspeed[i-temprowsmin]
          p2off[i-temprowsmin] = p2off[i-temprowsmin] + MPTspeed[i-temprowsmin] 
}




}



